// "react-router-dom": "^5.2.0",
import * as React from 'react';
import { Router, Switch, Route as _Route, Redirect, useLocation, useRouteMatch } from 'react-router-dom';
export { useLocation } from 'react-router-dom';
export function CustomRouter({ basename, children, future, history, }) {
    return React.createElement(Router, { history: history }, children);
}
export function Routes(props) {
    return React.createElement(Switch, null, props.children);
}
export function Route(props) {
    const { path: _path, element, Component, exact } = props;
    let path = React.useMemo(() => {
        var _a;
        const matched = (_a = _path === null || _path === void 0 ? void 0 : _path.match) === null || _a === void 0 ? void 0 : _a.call(_path, /(.*)\/\*$/);
        if (matched === null || matched === void 0 ? void 0 : matched[1]) {
            return matched === null || matched === void 0 ? void 0 : matched[1];
        }
        return _path === '*' ? undefined : _path;
    }, [_path]);
    return (React.createElement(_Route, { exact: exact, path: path, render: Component }, element));
}
export function Navigate({ to, replace }) {
    const location = useLocation();
    return (React.createElement(Redirect, { to: Object.assign(Object.assign({}, location), { pathname: to }) }));
}
export function useCurrentPath() {
    const { path } = useRouteMatch();
    return path;
}
/* <Router history={history}>
  <React.Suspense fallback={<Loading />}>
    <Switch>
      {home && (
        <Route
          path={`/${home.root || ''}`}
          exact
          render={({ location }) => {
            return (
              <Redirect
                to={{
                  ...location,
                  pathname: home.path,
                }}
              />
            );
          }}
        />
      )}
      {routes.map((route) => {
        // 采用 render 的方式 企业工作台内路由会有两次变化
        // 从而两次 render page 导致 widgets 引用异常
        // __POWERED_BY_QIANKUN__
        const Component = route.render;
        const adminPortal = simpleCheckAdminPortal();
        return (
          <Route key={route.path} path={route.path} render={adminPortal ? undefined : Component}>
            {adminPortal ? <Component /> : null}
          </Route>
        );
      })}
      <Route>{({ location }) => <NotFound path={location?.pathname} onNotFound={onNotFound} />}</Route>
    </Switch>
  </React.Suspense>
</Router>; */
