"use strict";
var _Query_instances, _Query_schema, _Query_context, _Query_triggered, _Query_initedResolver, _Query_disposes, _Query_dataBinds, _Query_action, _Query_paramsRef, _Query_emit, _Query_currentRequestKey, _Query_observableValue, _Query_innerTrigger, _Query_debounceTrigger, _Query_resolveParams, _Query_isSqlType_get;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Query = void 0;
const tslib_1 = require("tslib");
const cals_1 = require("@cloudbase/cals");
const mobx_1 = require("mobx");
const generate_1 = require("./adapter/generate");
const runtime_1 = require("./runtime");
const lodash_es_1 = require("lodash-es");
var EQUERY_PARAM_TYPE;
(function (EQUERY_PARAM_TYPE) {
    EQUERY_PARAM_TYPE["ARRAY"] = "ARRAY";
    EQUERY_PARAM_TYPE["BOOLEAN"] = "BOOLEAN";
    EQUERY_PARAM_TYPE["NUMBER"] = "NUMBER";
    EQUERY_PARAM_TYPE["OBJECT"] = "OBJECT";
    EQUERY_PARAM_TYPE["STRING"] = "STRING";
})(EQUERY_PARAM_TYPE || (EQUERY_PARAM_TYPE = {}));
class Query {
    constructor({ schema, context, options, }) {
        var _a, _b;
        _Query_instances.add(this);
        _Query_schema.set(this, void 0);
        _Query_context.set(this, void 0);
        _Query_triggered.set(this, false);
        _Query_initedResolver.set(this, (value) => { });
        _Query_disposes.set(this, []);
        _Query_dataBinds.set(this, {});
        _Query_action.set(this, void 0);
        _Query_paramsRef.set(this, (0, mobx_1.observable)({ current: null }));
        _Query_emit.set(this, void 0);
        _Query_currentRequestKey.set(this, null);
        _Query_observableValue.set(this, (0, mobx_1.observable)({
            data: null,
            error: null,
            isFetching: false,
        }));
        _Query_debounceTrigger.set(this, (0, lodash_es_1.debounce)(tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_innerTrigger), 300));
        const { looseError = false, useScopeWidgetData = false } = options;
        const { $w, $app, $page } = context;
        tslib_1.__classPrivateFieldSet(this, _Query_schema, (0, cals_1.normalizeQuery)(schema), "f");
        tslib_1.__classPrivateFieldSet(this, _Query_context, context, "f");
        this.initPromise = new Promise((resolve) => {
            tslib_1.__classPrivateFieldSet(this, _Query_initedResolver, resolve, "f");
        });
        if (((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.trigger) === 'auto') {
            tslib_1.__classPrivateFieldGet(this, _Query_disposes, "f").push((0, mobx_1.autorun)((r) => {
                // r.trace(true);
                try {
                    const data = tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_resolveParams).call(this);
                    if (tslib_1.__classPrivateFieldGet(this, _Query_triggered, "f")) {
                        tslib_1.__classPrivateFieldGet(this, _Query_debounceTrigger, "f").call(this, data);
                    }
                }
                catch (e) {
                    console.error(e);
                }
                finally {
                    tslib_1.__classPrivateFieldGet(this, _Query_initedResolver, "f").call(this, true);
                }
            }, { delay: 50 }));
        }
        else {
            tslib_1.__classPrivateFieldGet(this, _Query_initedResolver, "f").call(this, true);
        }
        const deserializeContext = ($page === null || $page === void 0 ? void 0 : $page.id)
            ? {
                page: { id: $page.id, type: cals_1.EComponentType.PAGE },
            }
            : {};
        const processedParams = (0, cals_1.deserializeDynamicMap)(deserializeContext, (0, cals_1.generateHandlerParamsDynamicMap)(tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").handler));
        const { staticData, dataBinds = [] } = (0, generate_1.splitDynamicMap)(processedParams);
        tslib_1.__classPrivateFieldGet(this, _Query_paramsRef, "f").current = staticData;
        tslib_1.__classPrivateFieldSet(this, _Query_dataBinds, (0, generate_1.generateDataBinds)({ $page, $app }, dataBinds === null || dataBinds === void 0 ? void 0 : dataBinds.filter((item) => {
            return !/[\s+\-*/!&|%]*?SERVER\./.test(item.propertyPath);
        }), Object.assign(Object.assign({ looseError,
            useScopeWidgetData }, options), { key: `${this.id} method.params` })), "f");
        tslib_1.__classPrivateFieldSet(this, _Query_action, tslib_1.__classPrivateFieldGet(this, _Query_instances, "a", _Query_isSqlType_get)
            ? function (data, options = {}) {
                return tslib_1.__awaiter(this, void 0, void 0, function* () {
                    let { debug = false } = options;
                    const requestData = {
                        EnvId: $w.env.envId,
                        Name: data.sqlTemplateId,
                        Parameter: JSON.stringify(Object.entries(data.params || {}).reduce((list, [key, value]) => {
                            if (value !== undefined) {
                                let type = EQUERY_PARAM_TYPE.OBJECT;
                                const typeofValue = typeof value;
                                switch (typeofValue) {
                                    case 'boolean': {
                                        type = EQUERY_PARAM_TYPE.BOOLEAN;
                                        break;
                                    }
                                    case 'number': {
                                        type = EQUERY_PARAM_TYPE.NUMBER;
                                        break;
                                    }
                                    case 'string': {
                                        type = EQUERY_PARAM_TYPE.STRING;
                                        break;
                                    }
                                    default: {
                                        if (Array.isArray(value)) {
                                            type = EQUERY_PARAM_TYPE.ARRAY;
                                        }
                                        else {
                                            type = EQUERY_PARAM_TYPE.OBJECT;
                                        }
                                    }
                                }
                                list.push({
                                    Key: key,
                                    Type: type,
                                    Value: type === EQUERY_PARAM_TYPE.STRING ? value : JSON.stringify(value),
                                });
                            }
                            return list;
                        }, []) || []),
                    };
                    let start = Date.now();
                    const Data = yield $w.cloud.callWedaApi({
                        action: 'RunQuery',
                        CallQuery: true,
                        QueryResource: tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type === 'sql' ? 'mysql-plugin' : 'mssql-plugin',
                        QueryPath: '/WeDa/Query/V1/RunPluginQuery',
                        EnvId: requestData.EnvId,
                        QueryName: requestData.Name,
                        data: requestData,
                        BackendLatency: !!debug,
                    });
                    // const Data = await $w.cloud.callWedaApi({
                    //   action: 'RunPluginQuery',
                    //   data: { MainAppId: $w.app.id, ...requestData },
                    // });
                    const { ExecuteResultList = [], Total, BackendExecute, BackendLatency } = Data || {};
                    const content = ExecuteResultList.join('');
                    const profile = {
                        backendExecude: Number(BackendExecute || 0),
                        backendLatency: Number(BackendLatency || 0),
                        /**
                         * 中文时有问题
                         * 但是不太关键，别用于关键逻辑判断
                         */
                        contentLength: content.length,
                        requestTimeCost: Date.now() - start,
                    };
                    try {
                        const encoder = new TextEncoder();
                        const bytes = encoder.encode(content);
                        profile.contentLength = bytes.length;
                    }
                    catch (e) { }
                    return {
                        records: ExecuteResultList.map((item) => JSON.parse(item)),
                        total: Total || ExecuteResultList.length,
                        profile: debug ? profile : undefined,
                    };
                });
            }
            : (0, lodash_es_1.get)($w.app, (_b = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").handler) === null || _b === void 0 ? void 0 : _b.name) ||
                function (data) {
                    throw new Error('Invalue query handler');
                }, "f");
        tslib_1.__classPrivateFieldSet(this, _Query_emit, (trigger, eventData, originalEvent) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            var _c;
            return (0, runtime_1.generateEmit)($w)(trigger, (0, generate_1.generateListnerInstances)({
                $app,
                $page,
                actionsMap: tslib_1.__classPrivateFieldGet(this, _Query_context, "f").actionsMap,
            }, tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").listeners || []), eventData, {}, originalEvent, {}, {}, 
            /**
             * 当 app 全局情况下
             * 不进行 pageId 判断
             */
            (_c = $w.page) === null || _c === void 0 ? void 0 : _c.id, true);
        }), "f");
        return this;
    }
    get id() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.id) || '';
    }
    get label() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.label) || '';
    }
    get description() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.description) || '';
    }
    get data() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data;
    }
    get error() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error;
    }
    get isFetching() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching;
    }
    trigger(additionalScope, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            tslib_1.__classPrivateFieldSet(this, _Query_triggered, true, "f");
            let start = Date.now();
            const resolvedParams = tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_resolveParams).call(this, additionalScope);
            const resolveParamsTimecost = Date.now() - start;
            const res = yield tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_innerTrigger).call(this, resolvedParams, options);
            if (res.profile) {
                res.profile = Object.assign(Object.assign({}, res.profile), { trrigerTimeCost: Date.now() - start, resolveParamsTimecost });
            }
            return res;
        });
    }
    reset() {
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = null;
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = null;
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
    }
    destroy() {
        tslib_1.__classPrivateFieldGet(this, _Query_disposes, "f").forEach((dispose) => dispose());
    }
    /**
     * 用于调试
     */
    _toSchema() {
        console.warn('调试使用，结构可能发生更改，请不要用于生产环境');
        return tslib_1.__classPrivateFieldGet(this, _Query_schema, "f");
    }
    toJSON() {
        const KEYS = ['id', 'label', 'description', 'data', 'error', 'isFetching', 'trigger', 'reset'];
        return KEYS.reduce((obj, key) => {
            obj[key] = this[key];
            return obj;
        }, {});
    }
}
exports.Query = Query;
_Query_schema = new WeakMap(), _Query_context = new WeakMap(), _Query_triggered = new WeakMap(), _Query_initedResolver = new WeakMap(), _Query_disposes = new WeakMap(), _Query_dataBinds = new WeakMap(), _Query_action = new WeakMap(), _Query_paramsRef = new WeakMap(), _Query_emit = new WeakMap(), _Query_currentRequestKey = new WeakMap(), _Query_observableValue = new WeakMap(), _Query_debounceTrigger = new WeakMap(), _Query_instances = new WeakSet(), _Query_innerTrigger = function _Query_innerTrigger(args, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        tslib_1.__classPrivateFieldSet(this, _Query_currentRequestKey, Date.now(), "f");
        const key = tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f");
        try {
            tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = true;
            const actionArgs = [args[0]];
            if (tslib_1.__classPrivateFieldGet(this, _Query_instances, "a", _Query_isSqlType_get)) {
                actionArgs.push(options);
            }
            const _a = yield tslib_1.__classPrivateFieldGet(this, _Query_action, "f").call(this, ...actionArgs), { profile } = _a, res = tslib_1.__rest(_a, ["profile"]);
            if (key === tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f")) {
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = res;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = null;
                tslib_1.__classPrivateFieldGet(this, _Query_emit, "f").call(this, `success`, res);
            }
            return Object.assign(Object.assign({}, res), { profile });
        }
        catch (e) {
            if (key === tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f")) {
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = null;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = e;
                tslib_1.__classPrivateFieldGet(this, _Query_emit, "f").call(this, `fail`, e);
            }
            throw e;
        }
    });
}, _Query_resolveParams = function _Query_resolveParams(additionalScope = {}) {
    /**
     * 这里万一其中某个字段计算失败
     * 好像会阻塞其他字段的计算
     * 从而导致 autorun 没有添加依赖
     */
    let { params = [] } = (0, runtime_1.mergeDynamic2StaticData)((0, mobx_1.toJS)(tslib_1.__classPrivateFieldGet(this, _Query_paramsRef, "f").current), tslib_1.__classPrivateFieldGet(this, _Query_dataBinds, "f"), {
        $w: tslib_1.__classPrivateFieldGet(this, _Query_context, "f").$w,
        paramsContext: additionalScope,
    }) || {};
    return params;
}, _Query_isSqlType_get = function _Query_isSqlType_get() {
    return tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type === 'sql' || tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type === 'sqlserver';
};
//# sourceMappingURL=query.js.map