import { LowCodeModuleParser, IEvaledModule, LowcodeContext } from './base';

export class HandlerParser implements LowCodeModuleParser {
  handler: any;

  onStart(context: LowcodeContext) {
    this.handler = {};
  }

  parseModule(pageId: string, mod: IEvaledModule) {
    if (mod.name === '____index____') return;

    const list = mod.path?.split('/');
    /**
     * migic number 3 from  const [, , folder] = mod.path?.split('/');
     */
    const folder = list.length < 3 ? undefined : list[list.length - 1];
    if (folder) {
      this.handler[pageId] = this.handler[pageId] || {};
      this.handler[pageId][folder] = mod.exports.default;
    } else this.handler[pageId] = mod.exports.default;
  }

  onEnd(context: LowcodeContext) {
    context.handler = this.handler;
  }
}
